﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;

namespace PureChat.Plugins.OnTime
{
	public partial class AddIncident : OnTimePluginControl
	{
		protected override void OnInit(EventArgs e)
		{
			base.OnInit(e);
			btnSave.Click += btnSave_Click;

			this.Page.ClientScript.RegisterStartupScript(this.GetType(), "searchCustomerPopupId", string.Format("searchCustomerContactPopupId = '{0}'; hidCustomerId = '{1}'; addCustomerPopupId = '{2}'; addCustomerContactPopupId = '{3}'; messagePopupId = '{4}'; searchCustomerPopupId = '{5}';", searchCustomerContactPopup.ClientID, hidCustomerContactId.ClientID, addCustomerPopup.ClientID, addCustomerContactPopup.ClientID, messagePopup.ClientID, searchCustomerPopup.ClientID), true);
			Control c = this.Page.FindControl("scriptManager");
			if (c != null)
			{
				System.Web.UI.ScriptManager scriptManager = (System.Web.UI.ScriptManager)c;
				scriptManager.Services.Add(new ServiceReference("~/plugins/OnTime/OnTimePluginService.asmx"));
			}
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			if (!IsPostBack)
			{
				txtIncidentName.Text = GetDefaultValue(Settings.IncidentDefaultValues.ContainsKey("Name") ? Settings.IncidentDefaultValues["Name"] : string.Empty);
				txtDescription.Text = string.Join(Environment.NewLine, ChatObject.ChatTranscript.ToArray());
				GetUserNames(ddlUsers, GetDefaultValue(Settings.IncidentDefaultValues.ContainsKey("AssignedToId") ? Settings.IncidentDefaultValues["AssignedToId"] : OperatorName));
				GetProjects(ddlProjects, GetDefaultValue(Settings.IncidentDefaultValues.ContainsKey("ProjectId") ? Settings.IncidentDefaultValues["ProjectId"] : string.Empty));
				GetStatusTypes(ddlStatus, GetDefaultValue(Settings.IncidentDefaultValues.ContainsKey("StatusTypeId") ? Settings.IncidentDefaultValues["StatusTypeId"] : string.Empty));
			}
		}

		protected void btnSave_Click(object sender, EventArgs e)
		{
			OnTimeSDK.Incident.Incident incident = new PureChat.Plugins.OnTimeSDK.Incident.Incident();
			incident.AssignedToId = int.Parse(ddlUsers.SelectedValue);
			incident.Name = txtIncidentName.Text.Trim();
			string description = txtDescription.Text;
			if (Settings.HtmlDetailFields)
				description = description.Replace(Environment.NewLine, "<br />");
			incident.Description = description;
			incident.ProjectId = ddlProjects.GetSelectedItemValue();
			if (!string.IsNullOrEmpty(ddlStatus.SelectedValue))
				incident.StatusTypeId = int.Parse(ddlStatus.SelectedValue);
			incident.ReportedByCustomerContactId = int.Parse(hidCustomerContactId.Value);
			
			int incidentid = 0;
			string incidentNumber = string.Empty;
			using (OnTimeSDK.Incident.IncidentHandler handler = new PureChat.Plugins.OnTimeSDK.Incident.IncidentHandler(Settings.IncidentServiceUrl))
			{
				incidentid = handler.AddIncident(Settings.SecurityGuid, incident);
				OnTimeSDK.Incident.Incident newIncident = handler.GetByIncidentId(Settings.SecurityGuid, incidentid);
				incidentNumber = newIncident.IncidentNumber;
			}
			Page.ClientScript.RegisterStartupScript(this.GetType(), "alertId", string.Format("afterMessageFunc = closeWindow; url = '{0}'; setTimeout('showSuccessMessage(\"Incident added successfully! Incident Number - {{0}}\");', 250);", GetItemIdUrl(incidentNumber, "incident")), true);
			
		}
	}
}